Skip to main content
Restrictive mode safeguards the pipeline against unintended or unsafe changes. You can enable restrictive mode for any query pipeline.
This feature is available starting in Lucidworks Search 5.9.15.
The default mode is permissive mode. When a query pipeline is in restrictive mode:
  • Only certain query parameters are allowed.
    Restrictive mode blocks parameters that could be used destructively.
  • Strict parameter validation and sanitization is applied.
    • The q and fq parameters are rejected if they contain LocalParams syntax ({!...}), which prevents parser-injection attacks. General Solr query syntax (field:value, booleans, wildcards, ranges, phrase queries) is still permitted.
    • The rows and start parameters must be less than 100 (valid range: 0–99).
    • The sort parameter is allowlisted but values are not validated against specific sortable fields.

Enabling restrictive mode

You can enable restrictive mode for any individual pipeline, in the Query Pipelines panel.
  1. Navigate to Query > Query Pipelines.
  2. Select the pipeline you want to secure.
  3. In the Parameter Validation field, select Restrictive.
Parameter Validation field in the Query Pipelines panel

Allowed parameters

The parameters listed below are allowed in restrictive mode. All other parameters are prohibited.
  • bf
  • boost
  • bq
  • callback
  • collection
  • context
  • cursorMark
  • debug
  • defType
  • echoParams
  • explainOther
  • facet.field
  • facet.limit
  • facet.mincount
  • facet.pivot
  • facet.query
  • facet.range
  • facet.sort
  • facet
  • fl
  • fq
  • hl.fl
  • hl.fragsize
  • hl.simple.post
  • hl.simple.pre
  • hl.snippets
  • hl
  • indent
  • json.facet
  • json.nl
  • json.wrf
  • mm
  • omitHeader
  • pf
  • ps
  • q
  • qf
  • qs
  • queryProfileID
  • requestHandler
  • rows
  • segmentTerminateEarly
  • sort
  • start
  • tie
  • timeAllowed
  • wt